
-- Mach250VRT
-- Specialization for Mach250VRT mod
-- Date 18/01/2016

Mach250VRT = {};

function Mach250VRT.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Mach250VRT:load(xmlFile)
    self.frontLinkageBottomArmRotNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm1#rotationNode"));
    setRotation(self.frontLinkageBottomArmRotNode1, math.rad(-85), math.rad(0), math.rad(0));
    self.frontLinkageBottomArmRotNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm2#rotationNode"));
    setRotation(self.frontLinkageBottomArmRotNode2, math.rad(-85), math.rad(0), math.rad(0));

    self.isSelectable = true
end;

function Mach250VRT:delete()
end;

function Mach250VRT:readStream(streamId, connection)
end;

function Mach250VRT:writeStream(streamId, connection)
end;

function Mach250VRT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Mach250VRT:keyEvent(unicode, sym, modifier, isDown)
end;

function Mach250VRT:update(dt)
end;

function Mach250VRT:updateTick(dt)
end;

function Mach250VRT:draw()
end;

function Mach250VRT:onLeave()
end;

function Mach250VRT:onEnter()
end;

function Mach250VRT:attachImplement(implement)
    local jointType = implement.object.attacherJoint.jointType;
    local jointIndex = implement.jointDescIndex;

    if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
        if implement.object.needsLowering then
            self.implementCount = math.max(self.implementCount - 1, 0);
        end;
        if jointIndex == 2 then
            setRotation(self.frontLinkageBottomArmRotNode1, math.rad(0), math.rad(0), math.rad(0));
            setRotation(self.frontLinkageBottomArmRotNode2, math.rad(0), math.rad(0), math.rad(0));
        end;
    elseif jointType == Vehicle.JOINTTYPE_TRAILER then
        if jointIndex == 3 then
        end;
    elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW then
        if jointIndex == 4 then
        end;
    end;

    self.updateJoint = true;
end;

function Mach250VRT:detachImplement(implementIndex)
    local implement = self.attachedImplements[implementIndex];
    local jointIndex = implement.jointDescIndex;

    if implement.object.attacherJoint.jointType == Vehicle.JOINTTYPE_IMPLEMENT then
        if implement.object.needsLowering then
            self.implementCount = self.implementCount + 1;
        end;
        if jointIndex == 2 then
            setRotation(self.frontLinkageBottomArmRotNode1, math.rad(-85), math.rad(0), math.rad(0));
            setRotation(self.frontLinkageBottomArmRotNode2, math.rad(-85), math.rad(0), math.rad(0));
        end;
    else
    end;

    self.updateJoint = true;
end;

function Mach250VRT:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;
